//+------------------------------------------------------------------+
//|                       4MAs-BiggerTimeFrameToSmallerTimeFrame.mq4 |
//|                                          Copyright  2015, trang | 
//|                 Partial Function Copyright  2006-2007, firedave | 
//|       Partial Function Copyright  2006-2007, pengie, codersguru |
//|                                                        version 1 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, trang"
/* 
@overview Expert Advidor: 4 Moving Averages - Bigger Time Frame to Smaller Time Frame
Step 1: Compare 1st and 2nd Moving Averages in a Big Time Frame  -> TREND : UP or DOWN?
Step 2: Compare 3rd and 4th Moving Averages in a Smaller Time Frame
Step 3: If Step 1 = UP   -> Only open BUY trade in Smaller Time Frame
        If Step 2 = DOWN -> Only open SELL trade in Smaller Time Frame
Step 4: Exit Trade? 3rd and 4th MAs Cross?
*/

enum trailingstop {
   After_Profit_Trailing_Stop = 1, 
   Instant_Trailing_Stop = 2
};
//----------------------- INCLUDES
#include <stdlib.mqh>

//----------------------- EA PARAMETER
extern string              Expert_Name          = "---------- Universal MA Cross EA v8.1";
extern int                 MagicNumber          = 1234;
extern int                 StopLoss             = 500,
                           TakeProfit           = 1000;
extern string              TrailingStop_Setting = "---------- Trailing Stop Setting";
extern trailingstop        TrailingStopType     = 2;
extern int                 TrailingStop         = 300;
extern string              Indicator_Setting    = "---------- Indicator Setting";
extern int                 FastMAPeriod         = 5;
extern ENUM_MA_METHOD      FastMAType           = 1;    //0:SMA 1:EMA 2:SMMA 3:LWMA
extern ENUM_APPLIED_PRICE  FastMAPrice          = 0;    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
extern int                 FastMAshift          = 0,
                           SlowMAPeriod         = 50;
extern ENUM_MA_METHOD      SlowMAType           = 1;    //0:SMA 1:EMA 2:SMMA 3:LWMA
extern ENUM_APPLIED_PRICE  SlowMAPrice          = 0;    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
extern int                 SlowMAshift          = 0;
extern string              CossDistance_Setting = "---------- Min Cross Distance Setting";
extern int                 MinCrossDistance     = 0,    //Always positive, 0:disable
                           MaxLookUp            = 0;    //Number of bar to keep checking for the entry condition
extern string              Exit_Setting         = "---------- Exit Setting";
extern bool                StopAndReverse       = false,  // TURE:if signal change, exit and reverse order
                           PureSAR              = false,  // TRUE:no SL, no TP, no TS
                           ExitOnCross          = true;
extern string              ThirdEMA_Setting     = "---------- Third MA Setting";
extern bool                UseThirdMA           = false,
                           UseCounterTrend      = false,
                           OnlyCounterTrend     = false;
extern int                 ThirdMAPeriod        = 100;
extern ENUM_MA_METHOD      ThirdMAType          = 1;    //0:SMA 1:EMA 2:SMMA 3:LWMA
extern ENUM_APPLIED_PRICE  ThirdMAPrice         = 0;    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
extern int                 ThirdMAshift         = 0,
                           CTStopLoss           = 0,
                           CTTakeProfit         = 0;
extern string              BiggerTimeFrame_Setting = "---------- Bigger Time Frame Setting";
extern bool                UseBiggerTimeFrame   = true;
extern ENUM_TIMEFRAMES     BiggerTimeFrame      = 240;   //1:M1, 5:M5, 15:M15, 30:M30, 60:H1, 240:H4, 1440=D1, 10080:W1, 43200:MN1
extern int                 BiggerFastMAPeriod   = 5;  
extern ENUM_MA_METHOD      BiggerFastMAType     = 1;    //0:SMA 1:EMA 2:SMMA 3:LWMA
extern ENUM_APPLIED_PRICE  BiggerFastMAPrice    = 0;    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
extern int                 BiggerFastMAshift    = 0,  
                           BiggerSlowMAPeriod   = 60;
extern ENUM_MA_METHOD      BiggerSlowMAType     = 1;    //0:SMA 1:EMA 2:SMMA 3:LWMA
extern ENUM_APPLIED_PRICE  BiggerSlowMAPrice    = 0;    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
extern int                 BiggerSlowMAshift    = 0;                                                             
extern string              PivotSetting        = "---------- Pivot Filter Setting";
extern bool                UsePivotFilter      = false;


/* reserve for future development
extern string              BGFilter_Setting     = "---------- BG Cross Filter Setting";
extern bool                UseBGFilter          = false;
extern int                 BGFilter             = 20;                  
*/
       
extern string              Order_Setting        = "---------- Order Setting";
extern bool                ReverseCondition     = false, // TRUE:buy-sell , sell-buy
                           ConfirmedOnEntry     = true,  // TRUE:entry on the next signal bar
                           OneEntryPerBar       = true;
extern int                 NumberOfTries        = 10,
                           Slippage             = 5;
extern string              OpenOrder_Setting    = "---------- Multiple Open Trade Setting";
extern int                 MaxOpenTrade         = 1,
                           MinPriceDistance     = 5;
extern string              Time_Parameters      = "---------- EA Active Time";
extern bool                UseHourTrade         = false;         
extern int                 StartHour            = 10,
                           EndHour              = 11;
extern string              Close_Setting        = "---------- Close Setting";
extern bool                CloseAllAtWeekend    = false; 
extern string              MM_Parameters        = "---------- Money Management";
extern double              Lots                 = 1;
extern bool                MM                   = false, //Use Money Management or not
                           AccountIsMicro       = false; //Use Micro-Account or not
extern int                 Risk                 = 10; //10%
extern string              Alert_Setting        = "---------- Alert Setting";
extern bool                EnableAlert          = true;
extern string              SoundFilename        = "alert.wav";
extern string              Testing_Parameters= "---------- Back Test Parameter";
extern bool                PrintControl         = true,
                           Show_Settings        = true;

//----------------------- GLOBAL VARIABLE
static int                 TimeFrame            = 0;
string                     TicketComment        = "4MAs-BiggerTimeFrame v1",
                           LastTrade,
                           LastAlert,
                           TradeDirection       = "NONE",
                           PreviousDirection    = "NONE",
                           CurrentDirection     = "NONE";
datetime                   CheckTime,
                           CheckEntryTime,
                           CrossTime;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{

//----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
	TicketComment  = StringConcatenate(TicketComment, "-", Symbol(), "-", Period());

/**----------------------- SET MinCrossDistance ALWAYS POSITIVE
@ requires 
@ modifies 
      MinCrossDistance  int
*/
   MinCrossDistance = MathAbs(MinCrossDistance);

//----------------------- SHOW EA SETTING ON THE CHART
//----------------------- SOURCE : CODERSGURU
   if(Show_Settings==true) subPrintDetails();
   else Comment("");
   
//----------------------- INITIALIZE PURE Stop And Reverse
/**----------------------- NO STOP LOSS, NO TAKE PROFIT, NO TRAILING STOP
@ modifies 
      StopLoss       int
      TakeProfit     int
      TrailingStop   int
      StopAndReverse boolean
*/
   if(PureSAR==true)
   {
      StopLoss       = 0;
      TakeProfit     = 0;
      TrailingStop   = 0;
      StopAndReverse = true;
   }

/**----------------------- MaxTrade ALWAYS >= 1
@ modifies
      MaxOpenTrade   int
*/
   if(MaxOpenTrade<=0) MaxOpenTrade = 1;
   
//+------------------------------------------------------------------+
//| CHECK LAST OPEN TRADE                                            |
//+------------------------------------------------------------------+
   LastTrade = subCheckOpenTrade();
   Print("Last Trade : ",LastTrade);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
 
//----------------------- PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME
//----------------------- SOURCE : CODERSGURU
   TimeFrame=Period(); 
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
    int start()
    {
        double FastMACurrent;
        double SlowMACurrent;
        double ThirdMAValue;
        double BiggerFastMAValue;
        double BiggerSlowMAValue;
        double LastHigh;
        double LastLow;
        double LastClose;
        double P;
        double S1;
        double R1;
        double S2;
        double R2;

        int cnt;
        int ticket;
        int total;
        int shiftCROSS;
        int Distance;

        bool BuyCondition = false;
        bool SellCondition = false;
        bool CounterTrend = false;

        string CrossDirection;         

        /**----------------------- CLOSE ALL AT WEEKEND FILTER
                  * @requires
                  *      Global Parameters
                  *          CloseAllAtWeekend  boolean
                  *      Start() Variables
                  * @modify
                  * @effects
                  *      if time is at 23:40 (server time) of Friday
                  *          Close All Orders
                  *          Stop Program
                  *
                  */
        if (CloseAllAtWeekend==true)
        {
            if(DayOfWeek()==5  && Hour()==23 && Minute()>=40)
            {
                subCloseOrder();
                Comment("Close all at the end of the week!");
                return(0);
            }
        }

        /**----------------------- TIME FILTER
                  * @requires
                  *      Global Parameters
                  *          StartHour    int
                  *          EndHour      int
                  *          ShowSetting  boolean
                  *      Start() Variables
                  * @modify
                  * @effects
                  *      if time is not between [Start Hour] and [End Hour]
                  *          Comment:"None Trading Hour!"
                  *          Stop Program
                  *      else 
                  *          if [Show_Settings] eq true
                  *              {@link #subPrintDetails():void}
                  *          else
                  *              Comment:""
                  *
                  */
        if (UseHourTrade==true)
        {
            if(!(Hour()>=StartHour && Hour()<=EndHour))
            {
                Comment("Non-Trading Hours!");
                return(0);
            }
            else{
                if(Show_Settings==true) subPrintDetails();
                else Comment("");

            }
        }

        /**----------------------- CHECK CHART NEED MORE THAN 100 BARS
                  * @requires 
                  * @modifies
                  * @effects
                  *      if number of bars is less than 100
                  *          Print:"Bars less than 100"
                  *          Stop Program
                  */
        if(Bars<100)
        {
            Print("bars less than 100");
            return(0);  
        }

        /**----------------------- TRAILING STOP SECTION
                  * @requires
                  *      Global Parameters
                  *          TrailingStop  int
                  *      Start() Variables
                  *          cnt    int
                  *          total  int       
                  * @modifies
                  * @effects
                  *      if [TrailingStop] gt 0 /\ {@link #subTotalTrade():int} gt 0
                  *          for each trade
                  *              if type of trade is Sell or Buy /\ this.Symbol, this.MagicNumber
                  *                  {@link #subTrailingStop(int): void}
                  */

        if(TrailingStop>0 && subTotalTrade()>0)
        {
            total = OrdersTotal();
            for(cnt=0;cnt<total;cnt++)
            {
                OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
                if(OrderType()<=OP_SELL &&
                OrderSymbol()==Symbol() &&
                OrderMagicNumber()==MagicNumber)
                {
                    subTrailingStop(OrderType());
                }
            }
        }                  

        /**----------------------- ADJUST LOTS IF USING MONEY MANAGEMENT
                  * @requires
                  *      Global Parameters
                  *          Lots  double
                  *          MM    boolean
                  *      Start() Variables
                  * @modifies Lots
                  * @effects
                  *          if [MM] eq true
                  *              [Lots] eq {@link #subLotSize()}: re-calculate lot size based on Money Management
                  */
        if(MM==true) Lots = subLotSize();

        /**----------------------- SET VALUE FOR VARIABLE
                  * @requires 
                  *      Global Parameters
                  *          FastMAPeriod       int
                  *          FastMAType         int
                  *          FastMAPrice        int
                  *          FastMAshift        int
                  *          SlowMAPeriod       int
                  *          SlowMAType         int
                  *          SlowMAPrice        int
                  *          SlowMAshift        int
                  *          TimeFrame          int
                  *          ConfirmedOnEntry   boolean
                  *          CheckTime          datetime
                  *      Start() Variables
                  *          FastMACurrent   double
                  *          SlowMACurrent   double
                  *          CrossDirection  double
                  * @modifies
                  *      Global Parameters
                  *          CheckTime          datetime
                  *      Start() Variables
                  *          FastMACurrent   double
                  *          SlowMACurrent   double
                  *          CrossDirection  string
                  * @effects
                  *      if [ConfirmedOnEntry] eq true
                  *          if [CheckTime] eq .....
                  *              Stop Program
                  *          else
                  *              [CheckTime] eq ......
                  *              [FastMACurrent] eq .... 
                  *              [SlowMACurrent] eq ....
                  *     else
                  *          [FastMACurrent] eq .... 
                  *          [SlowMACurrent] eq ....
                  *     [CrossDirection] eq {@link #subCrossDirection(double FastMACurrent,double SlowMACurrent):string}
                  */
        if(ConfirmedOnEntry==true)
        {
            if(CheckTime==iTime(NULL,TimeFrame,0)) 
                return(0); 
            else
                CheckTime = iTime(NULL,TimeFrame,0);

            FastMACurrent    = iMA(NULL,TimeFrame,FastMAPeriod,FastMAshift,FastMAType,FastMAPrice,1);
            SlowMACurrent    = iMA(NULL,TimeFrame,SlowMAPeriod,SlowMAshift,SlowMAType,SlowMAPrice,1);
        }
        else
        {
            FastMACurrent    = iMA(NULL,TimeFrame,FastMAPeriod,FastMAshift,FastMAType,FastMAPrice,0);
            SlowMACurrent    = iMA(NULL,TimeFrame,SlowMAPeriod,SlowMAshift,SlowMAType,SlowMAPrice,0);
        }

        CrossDirection = subCrossDirection(FastMACurrent,SlowMACurrent);

        /**----------------------- CONDITION CHECK
                  * @requires
                  *      Global Parameters
                  *          ReverseCondition boolean
                  *          TradeDirection   string
                  *          CrossTime        string
                  *          PrintControl     boolean
                  *          TimeFrame        int
                  *      Start() Variables
                  *          CrossDirection   string
                  *          BuyCondition     boolean
                  *          SellCondition    boolean
                  * @modifies
                  *      Global Parameters
                  *          TradeDirection   string
                  *          CrossTime        datetime
                  *      Start() Variables
                  *          BuyCondition     boolean
                  *          SellCondition    boolean
                  * @effects
                  *      if [ReverseCondition] eq false
                  *          if [CrossDirection] eq UP
                  *              [BuyCondition] eq true
                  *              [TradeDirection] eq UP
                  *              [CrossTime] eq ....
                  *          else
                  *              [SellCondition] eq true
                  *              [TradeDirection] eq DOWN
                  *              [CrossTime] eq ....  
                  *     else
                  *          if [CrossDirection] eq UP
                  *              [SellCondition] eq true
                  *              [TradeDirection] eq UP
                  *              [CrossTime] eq ....  
                  *          else
                  *              [BuyCondition] eq true
                  *              [TradeDirection] eq DOWN
                  *              [CrossTime] eq ....    
                  *    if [PrintControl] eq true
                  *          if [BuyCondition] eq true
                  *              Print:"MA Cross Buy"
                  *          if [SellCondition] eq true
                  *              Print:"MA Cross Sell" 
                  */
        if(ReverseCondition==false)
        {
            //----------------------- BUY CONDITION   
            if(CrossDirection=="UP")
            {
                BuyCondition   = true;
                TradeDirection = "UP";
                CrossTime      = iTime(NULL,TimeFrame,0);
            }                       

            //----------------------- SELL CONDITION   
            if(CrossDirection=="DOWN")
            {
                SellCondition  = true;
                TradeDirection = "DOWN";
                CrossTime      = iTime(NULL,TimeFrame,0);
            }
        }
        else
        {
            //----------------------- SELL CONDITION   
            if(CrossDirection=="UP")
            {
                SellCondition  = true;
                TradeDirection = "UP";
                CrossTime      = iTime(NULL,TimeFrame,0);
            }                       

            //----------------------- BUY CONDITION   
            if(CrossDirection=="DOWN")
            {
                BuyCondition   = true;
                TradeDirection = "DOWN";
                CrossTime      = iTime(NULL,TimeFrame,0);
            }
        }                        

        if(PrintControl==true)
        {
            if(BuyCondition==true)  Print("MA Cross BUY");
            if(SellCondition==true) Print("MA Cross SELL");
        }      

        //----------------------- ALERT ON CROSS
        if(EnableAlert==true && ConfirmedOnEntry==true)
        {
            if(TradeDirection=="UP" && LastAlert!="UP")
            {
                subCrossAlert("UP");
                LastAlert = "UP";
            }            
            if(TradeDirection=="DOWN" && LastAlert!="DOWN")
            {
                subCrossAlert("DOWN");
                LastAlert ="DOWN";
            }
        }                        

        /** EXIT BASE ONLY ON MOVING AVERAGE CROSS                        
                  * @requires
                  *      Global Parameters
                  *          ExitOnCross     boolean
                  *          PrintControl    boolean
                  *          LastTrade       string
                  *      Start() Variables
                  *          SellCondition   boolean
                  *          BuyCondition    boolean
                  * @modifies
                  * @effects
                  *      if ([ExitOnCross] eq true /\ {@link #subTotalTrade()} gt 0
                  *          if ([LastTrade] eq BUY /\ [SellCondition] eq true) \/
                  *             ([LastTrade] eq SELL /\ [BuyCondition] eq true )
                  *              {@link #subCloseOrder()}: close trade
                  *          if IsTesting /\ [PrintControl] eq true
                  *              Print:"Exit On Cross!"
                  */

        if(ExitOnCross==true && subTotalTrade()>0)
        {
            if((LastTrade=="BUY" && SellCondition==true) || (LastTrade=="SELL" && BuyCondition==true))
            {
                subCloseOrder();
                if(subTotalTrade()>0) 
                    subCloseOrder();
                if(subTotalTrade()>0) 
                    subCloseOrder();
                if(IsTesting() && PrintControl==true) Print("EXIT ON CROSS !");
            }
        }

        /** CHECKING FOR MIN CROSS DISTANCE SEVERAL BAR AFTER THE CROSS           
                  * @requires
                  *      Global Parameters
                  *          MaxLookUp           boolean
                  *          MinCrossDistance    boolean
                  *          ReverseCondition    boolean
                  *          PrintControl        boolean
                  *          TradeDirection      string
                  *          TimeFrame           int
                  *          CrossTime           datetime
                  *      Start() Variables
                  *          BuyCondition        boolean
                  *          SellCondition       boolean
                  *          shiftCROSS          int
                  *          Distance            int
                  * @modifies
                  *      Global Parameters
                  *      Start() Variables
                  *          BuyCondition        boolean
                  *          SellCondition       boolean
                  *          shiftCROSS          int
                  *          Distance            int       
                  * @effects
                  *      if use [MaxLookUp] && [MinCrossDistance]
                  *          [BuyCondition] eq false
                  *          [SellCondition] eq false
                  *          [shiftCROSS] eq iBarShift()...
                  *          [Distance] eq MathFloor()..
                  *          if [shiftCROSS] leq [MaxLookUp] /\ [Distance] geq [MinCrossDistance]
                  *              if [ReverseCondition] eq false
                  *                  if [TradeDirection] eq UP
                  *                      [BuyCondition] eq true
                  *                  if [TradeDirection] eq DOWN
                  *                      [SellCondition] eq true
                  *              else
                  *                  if [TradeDirection] eq UP
                  *                      [SellCondition] eq true
                  *                  if [TradeDirection] eq DOWN
                  *                      [BuyCondition] eq true
                  *          if [PrintControl] eq true
                  *              Print:"..."
                  *              if [BuyCondition] eq true 
                  *                  Print:"MinCrosDistance BUY"
                  *              if [SellCondition] eq true
                  *                  Print:"MinCrosDistance SELL"
                  *          
                  */

        if(MaxLookUp>0 && MinCrossDistance>0)
        {
            BuyCondition  = false;
            SellCondition = false;
            shiftCROSS    = iBarShift(NULL,TimeFrame,CrossTime);
            Distance      = MathFloor(MathAbs((FastMACurrent-SlowMACurrent)/Point));

            if(shiftCROSS<=MaxLookUp && Distance>=MinCrossDistance)
            {
                if(ReverseCondition==false)
                {
                    if(TradeDirection=="UP")   BuyCondition  = true;
                    if(TradeDirection=="DOWN") SellCondition = true;
                }
                else
                {
                    if(TradeDirection=="UP")   SellCondition = true;
                    if(TradeDirection=="DOWN") BuyCondition  = true;
                }
            }

            if(PrintControl==true)
            {
                Print(TimeToStr(CrossTime,TIME_MINUTES)," - ",shiftCROSS," - ",Distance," - ",MinCrossDistance," - ",TradeDirection);
                if(BuyCondition==true ) Print("MinCrosDistance BUY");
                if(SellCondition==true) Print("MinCrosDistance SELL");
            }
        }

        //+----------------------------------------------------------------------------------------------------------------------------------------------+
        //| ADDITIONAL FILTER                                                                                                                                                   |
        //+----------------------------------------------------------------------------------------------------------------------------------------------+

        /** THIRD MOVING AVERAGE                                                      
                  * @requires
                  *      Global Parameters
                  *          UseThirdMA          boolean
                  *          OnlyCounterTrend    boolean
                  *          TimeFrame           int
                  *      Start() Variables
                  *          SlowMACurrent   double
                  *          FastMACurrent   double
                  *          ThirdMAValue    double
                  *          CounterTrend    double
                  *          SellCondition   boolean
                  *          BuyCondition    boolean
                  * @modifies
                  *      Global Parameters
                  *      Start() Variables
                  *          ThirdMAValue    double
                  *          CounterTrend    double
                  *          SellCondition   boolean
                  *          BuyCondition    boolean
                  * @effects
                  *      [ThirdMAValue] eq iMA()..
                  *      if [UseCounterTrend] eq false
                  *          if [BuyCondition] eq true /\ [SlowMACurrent] gt [ThirdMACurrent]
                  *              [BuyCondition] eq true
                  *          else
                  *              [BuyCondition] eq false
                  *          if [SellCondition] eq true /\ [SlowMACurrent] gt [ThirdMACurrent]
                  *              [SellCondition] eq true
                  *          else
                  *              [SellCondition] eq false
                  *      else
                  *          if [BuyCondition] eq true /\ [FastMACurrent] lt [ThirdMACurrent] or [SellCondition] eq true /\ [FastMACurrent] gt [ThirdMACurrent]
                  *              [CounterTrend] eq true
                  *          else
                  *              [CounterTrend] eq false
                  *          if [OnlyCounterTrend] eq true /\ [CounterTrend] eq false
                  *              [BuyCondition] eq false
                  *              [SellCondition] eq false
                  *      
                  */

        if(UseThirdMA==true)
        {
            ThirdMAValue = iMA(NULL,TimeFrame,ThirdMAPeriod,ThirdMAshift,ThirdMAType,ThirdMAPrice,0);

            if(UseCounterTrend==false)
            {      
                if(BuyCondition==true  && SlowMACurrent>ThirdMAValue) BuyCondition  = true; else BuyCondition  = false;
                if(SellCondition==true && SlowMACurrent<ThirdMAValue) SellCondition = true; else SellCondition = false;
            }
            else
            {
                if((BuyCondition==true && FastMACurrent<ThirdMAValue) || (SellCondition==true && FastMACurrent>ThirdMAValue)) 
                    CounterTrend = true; 
                else 
                    CounterTrend = false;

                //+------------------------------------------------------------------------------------------------------------------+
                //| DON'T ALLOW ANY TREND FOLLOWING ENTRY / ONLY COUNTER TREND       |
                //+-------------------------------------------------------------------------------------------------------------------+
                if(OnlyCounterTrend==true && CounterTrend==false)
                {
                    BuyCondition  = false;
                    SellCondition = false;
                }
            }
        }

        /** BIGGER TIME FRAME                                                      
                  * @requires
                  *      Global Parameters
                  *          UseBiggerTimeFrame     boolean
                  *          BiggerTimeFrame        int
                  *      Start() Variables
                  *          BiggerFastMAPeriod      double
                  *          BiggerFastMAshift       double
                  *          BiggerFastMAType        double
                  *          BiggerFastMAPrice       double
                  *          BiggerSlowMAPeriod      double
                  *          BiggerSlowMAshift       double
                  *          BiggerSlowMAType        double
                  *          BiggerSlowMAPrice       double                  
                  *          SellCondition           boolean
                  *          BuyCondition            boolean
                  * @modifies
                  *      Global Parameters
                  *      Start() Variables
                  *          BiggerFastMAValue    double
                  *          BiggerSlowMAValue    double
                  *          SellCondition   boolean
                  *          BuyCondition    boolean
                  * @effects
                  *      [BiggerFastMAValue] eq iMA()..
                  *      [BiggerSlowMAValue] eq iMA()..
                  *      if [BuyCondition] eq true /\ [BiggerFastMAValue] gt [BiggerSlowMAValue]
                  *          [BuyCondition] eq true
                  *      else
                  *          [BuyCondition] eq false
                  *      if [SellCondition] eq true /\ [BiggerFastMAValue] lt [BiggerSlowMAValue]
                  *          [SellCondition] eq true
                  *      else
                  *          [SellCondition] eq false
                  *      
                  */

        if(UseBiggerTimeFrame==true)
        {
            BiggerFastMAValue = iMA(NULL,BiggerTimeFrame,BiggerFastMAPeriod,BiggerFastMAshift,BiggerFastMAType,BiggerFastMAPrice,0);
            BiggerSlowMAValue = iMA(NULL,BiggerTimeFrame,BiggerSlowMAPeriod,BiggerSlowMAshift,BiggerSlowMAType,BiggerSlowMAPrice,0);
     
            if(BuyCondition==true  && BiggerFastMAValue>BiggerSlowMAValue) BuyCondition  = true; else BuyCondition  = false;
            if(SellCondition==true && BiggerFastMAValue<BiggerSlowMAValue) SellCondition = true; else SellCondition = false;
        }

        /** PIVOT FILTER                        
                  * @requires
                  *      Global Parameters
                  *          UsePivotFilter     boolean
                  *      Start() Variables
                  *          LastHigh           double
                  *          LastLow            double
                  *          LastClose          double
                  *          P                  double
                  *          R1                 double
                  *          R2                 double
                  *          S1                 double
                  *          S2                 double
                  *          BuyCondition       boolean
                  *          SellCondition      boolean
                  *          SlowMACurrent      double
                  * @modifies
                  *      Global Parameters
                  *      Start() Variables
                  *          LastHigh           double
                  *          LastLow            double
                  *          LastClose          double
                  *          P                  double
                  *          R1                 double
                  *          R2                 double
                  *          S1                 double
                  *          S2                 double
                  *          BuyCondition       boolean
                  *          SellCondition      boolean
                  * @effects
                  *      [LastHigh] eq iHigh()..
                  *      [LastLow] eq iLow()..
                  *      [LastClose] eq iClose()..
                  *      [P] eq ([LastHigh]+[LastLow]+[LastClose])/3
                  *      [R1] eq (2*P)-LastLow
                  *      [S1] eq (2*P)-LastHigh
                  *      [R2] eq P+(LastHigh - LastLow)
                  *      [S2] eq P-(LastHigh - LastLow)
                  *      if [BuyCondition] eq true /\ [SlowMACurrent] leq [S1] /\ [SlowMACurrent] geq [S2]
                  *          [BuyCondition] eq true
                  *      else
                  *          [BuyCondition] eq false
                  *      if [SellCondition] eq true /\ [SlowMACurrent] geq [R1] /\ [SlowMACurrent] leq [R2]
                  *          [SellCondition] eq true
                  *      else
                  *          [SellCondition] eq true
                  */
        if(UsePivotFilter==true)
        {
            LastHigh  = iHigh (NULL,PERIOD_D1,1);
            LastLow   = iLow  (NULL,PERIOD_D1,1);
            LastClose = iClose(NULL,PERIOD_D1,1);
            P         = (LastHigh + LastLow+ LastClose)/3;
            R1        = (2*P)-LastLow;
            S1        = (2*P)-LastHigh;
            R2        = P+(LastHigh - LastLow);
            S2        = P-(LastHigh - LastLow);

            if(BuyCondition==true  && SlowMACurrent<=S1 && SlowMACurrent>=S2)
                BuyCondition  =  true; 
            else 
                BuyCondition  = false;
            if(SellCondition==true && SlowMACurrent>=R1 && SlowMACurrent<=R2) 
                SellCondition =  true; 
            else 
                SellCondition = false;
        }

       
        /** STOP AND REVERSE                         
                  * @requires
                  *      Global Parameters
                  *          StopAnReverse     boolean
                  *          PrintControl    boolean
                  *          LastTrade       string
                  *      Start() Variables
                  *          SellCondition   boolean
                  *          BuyCondition    boolean
                  * @modifies
                  * @effects
                  *      if ([StopAndReverse] eq true /\ {@link #subTotalTrade()} gt 0
                  *          if ([LastTrade] eq BUY /\ [SellCondition] eq true) \/
                  *             ([LastTrade] eq SELL /\ [BuyCondition] eq true )
                  *              {@link #subCloseOrder()}: close trade
                  *          if IsTesting /\ [PrintControl] eq true
                  *              Print:"Stop and Reverse!"
                  */
        if(StopAndReverse==true && subTotalTrade()>0)
        {
            if((LastTrade=="BUY" && SellCondition==true) || (LastTrade=="SELL" && BuyCondition==true))
            {
                subCloseOrder();
                if(subTotalTrade()>0) subCloseOrder();
                if(subTotalTrade()>0) subCloseOrder();

                if(IsTesting() && PrintControl==true) Print("STOP AND REVERSE !");
            }
        }

        /**----------------------- ENTRY
                  *----------------------- TOTAL ORDER BASE ON MAGICNUMBER AND SYMBOL
                  * @requires
                  *      Global Parameters
                  *          StopLoss        double
                  *          TakeProfit      double
                  *          MaxOpenTrade    int
                  *          OneEntryPerBar  boolean
                  *          CTStopLoss      double
                  *          CTTakeProfit    double
                  *          LastTrade       string
                  *          CheckEntryTime  datetime
                  *          TimeFrame       int
                  *      Start() Variables
                  *          ticket          int
                  *          total           int
                  *          BuyCondition    boolean
                  *          SellCondition   boolean
                  *          CounterTrend    boolean
                  * @modifies
                  *      Global Parameters
                  *          LastTrade       string
                  *          CheckEntryTime  datetime
                  *      Start() Variables
                  *          ticket          int
                  *          total           int
                  * @effects
                  *      if [total] lt [MaxOpenTrade] /\ [BuyCondition] or [SelCondition] eq true
                  *          if [OneEntryPerBar] eq true
                  *              if [CheckEntryTime] eq iTime()..
                  *                  return 0
                  *              else
                  *                  [CheckEntryTime] eq iTime()..
                  *          if [BuyCondition] eq true
                  *              if [MaxOpenTrade] gt 1 /\ {@link #subHighestLowest(string BUY)}: eq false 
                  *                  return (0)
                  *              if [CounterTrend] eq false
                  *                  [ticket] = {@link #subOpenOrder(OP_BUY,StopLoss,TakeProfit)}: open an order BUY
                  *              else
                  *                  [ticket] = {@link #subOpenOrder(OP_BUY,CTStopLoss,CTTakeProfit)}: open an order BUY with CT StopLoss and CT Profit
                  *              {@link #subCheckError(ticket,"BUY")}: check order error
                  *              [LastTrade] eq BUY
                  *              return(0)
                  *          if [SellCondition] eq true
                  *              if [MaxOpenTrade] gt 1 /\ {@link #subHighestLowest(string BUY)}: eq false 
                  *                  return (0)
                  *              if [CounterTrend] eq false
                  *                  [ticket] = {@link #subOpenOrder(OP_SELL,StopLoss,TakeProfit)}: open an order SELL
                  *              else
                  *                  [ticket] = {@link #subOpenOrder(OP_SELL,CTStopLoss,CTTakeProfit)}: open an order SELL
                  *              {@link #subCheckError(ticket,"SELL")}: check order error
                  *              [LastTrade] eq SELL
                  *              return(0)
                  *         return (0)
                  *     return (0)
                  */

        total = subTotalTrade();

        //----------------------- IF NUMBER TRADE LESS THAN MaxTrade
        if(total<MaxOpenTrade && (BuyCondition==true || SellCondition==true)) 
        {

            //----------------------- ONE ENTRY PER BAR
            if(OneEntryPerBar==true)
            {
                if(CheckEntryTime==iTime(NULL,TimeFrame,0)) 
                    return(0); 
                else 
                    CheckEntryTime = iTime(NULL,TimeFrame,0);
            }         

            //----------------------- BUY CONDITION   
            if(BuyCondition==true)
            {
                if(MaxOpenTrade>1 && subHighestLowest("BUY")==false) return(0);

                if(CounterTrend==false)
                {
                    ticket = subOpenOrder(OP_BUY,StopLoss,TakeProfit);
                    if(ticket<=0) 
                        ticket = subOpenOrder(OP_BUY,StopLoss,TakeProfit);
                    if(ticket<=0) 
                        ticket = subOpenOrder(OP_BUY,StopLoss,TakeProfit);
                }
                else
                {
                    ticket = subOpenOrder(OP_BUY,CTStopLoss,CTTakeProfit);
                    if(ticket<=0) 
                        ticket = subOpenOrder(OP_BUY,CTStopLoss,CTTakeProfit);
                    if(ticket<=0) 
                        ticket = subOpenOrder(OP_BUY,CTStopLoss,CTTakeProfit);
                }
                subCheckError(ticket,"BUY");
                LastTrade = "BUY";
                return(0);
            }

            //----------------------- SELL CONDITION   
            if(SellCondition==true)
            {
                if(MaxOpenTrade>1 && subHighestLowest("SELL")==false) return(0);

                if(CounterTrend==false)
                {
                    ticket = subOpenOrder(OP_SELL,StopLoss,TakeProfit);
                    if(ticket<=0) 
                        ticket = subOpenOrder(OP_SELL,StopLoss,TakeProfit);
                    if(ticket<=0) 
                        ticket = subOpenOrder(OP_SELL,StopLoss,TakeProfit);
                }
                else
                {
                    ticket = subOpenOrder(OP_SELL,CTStopLoss,CTTakeProfit);
                    if(ticket<=0) 
                        ticket = subOpenOrder(OP_SELL,CTStopLoss,CTTakeProfit);
                    if(ticket<=0) 
                        ticket = subOpenOrder(OP_SELL,CTStopLoss,CTTakeProfit);
                }
                subCheckError(ticket,"SELL");
                LastTrade = "SELL";
                return(0);
            }
            return(0);
        }

        return(0);
        
        }

//----------------------- END PROGRAM

//+------------------------------------------------------------------+
//| FUNCTION DEFINITIONS
//+------------------------------------------------------------------+

    /**----------------------- MONEY MANAGEMENT FUNCTION  
     *----------------------- SOURCE : CODERSGURU
     * @requires
     *      Global Parameters
     *          Lots                double
     *          AccountIsMicro      double
     *          Risk                int        
     * @modifies
     * @effects
     *      return lotMM
     */
    double subLotSize()
    {
        double lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;

        if(AccountIsMicro==false) //normal account
        {
            if(lotMM < 0.1)                  lotMM = Lots;
            if((lotMM > 0.5) && (lotMM < 1)) lotMM = 0.5;
            if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
            if(lotMM > 100)                  lotMM = 100;
        }
        else //micro account
        {
            if(lotMM < 0.01)                 lotMM = Lots;
            if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
            if(lotMM > 100)                  lotMM = 100;
        }

        return (lotMM);
    }

    /**----------------------- NUMBER OF ORDER BASE ON SYMBOL AND MAGICNUMBER FUNCTION
     * count the number of open trades that have same Symbol and same Magic Number
     */
    int subTotalTrade()
    {
        int cnt;
        int total = 0;

        for(cnt=0;cnt<OrdersTotal();cnt++)
        {
            OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
            if(OrderType()<=OP_SELL &&
            OrderSymbol()==Symbol() &&
            OrderMagicNumber()==MagicNumber) total++;
        }
        return(total);
    }

    //+------------------------------------------------------------------+
    //| FUNCTION : CHECK OPEN ORDER BASE ON SYMBOL AND MAGIC NUMBER      |
    //| SOURCE   : n/a                                                   |
    //| MODIFIED : FIREDAVE                                              |
    //+------------------------------------------------------------------+
    /**
     * Check the Last trade is SELL or BUY?
     */
    string subCheckOpenTrade()
    {
        int cnt = 0;
        string lasttrade = "None";      

        for(cnt=0;cnt<OrdersTotal();cnt++)
        {
            OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
            if(OrderType()<=OP_SELL &&
            OrderSymbol()==Symbol() &&
            OrderMagicNumber()==MagicNumber)
            {
                if(OrderType()==OP_BUY ) lasttrade = "BUY";
                if(OrderType()==OP_SELL) lasttrade = "SELL";
            }         
        }
        return(lasttrade);
    }

    /**----------------------- FIND LOWEST/HIGHEST BUY-SELL FUNCTION
     * Check :true or fall
     */
    bool subHighestLowest(string type)
    {
        int cnt;
        int total = 0;

        double HighestBuy  = 0;
        double LowestBuy   = 10000;
        double HighestSell = 0;
        double LowestSell  = 10000;

        for(cnt=0;cnt<OrdersTotal();cnt++)
        {
            OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
            if(OrderType()<=OP_SELL &&
            OrderSymbol()==Symbol() &&
            OrderMagicNumber()==MagicNumber)
            {
                if(OrderType()==OP_BUY)
                {
                    if(OrderOpenPrice()<LowestBuy ) LowestBuy  = OrderOpenPrice();
                    if(OrderOpenPrice()>HighestBuy) HighestBuy = OrderOpenPrice();
                }

                if(OrderType()==OP_SELL)
                {
                    if(OrderOpenPrice()<LowestSell ) LowestSell  = OrderOpenPrice();
                    if(OrderOpenPrice()>HighestSell) HighestSell = OrderOpenPrice();
                }

            }
        }

        if (type=="BUY"  && (Ask<=LowestBuy -MinPriceDistance*Point || Ask>=HighestBuy +MinPriceDistance*Point)) return(true);
        else if(type=="SELL" && (Bid<=LowestSell-MinPriceDistance*Point || Bid>=HighestSell+MinPriceDistance*Point)) return(true);
        else return(false);
    }

    //+------------------------------------------------------------------+
    //| FUNCTION : CHECK IS CROSS OR NOT                                 |
    //| SOURCE   : CODERSGURU                                            |
    //| MODIFIED : FIREDAVE                                              |
    //+------------------------------------------------------------------+
    /**
     * @effects 
     *      if fastMA gt slowMA
     *          [CurrentDirection] eq UP
     *      else
     *          [CurrentDirection] eq DOWN
     *          
     *      if [PrintControl] eq true 
     *          Print: "Prev: - Current:"
     *          
     *      if [PreviousDirection] eq NONE
     *          [PreviousDirection] eq [CurrentDirection]
     *          return NONE
     *      else
     *          [PreviousDirection] eq [CurrentDirection]
     *          return [CurrentDirection]    
     */
    string subCrossDirection(double fastMA, double slowMA)
    {
        if(fastMA>slowMA) CurrentDirection = "UP";
        else if(fastMA<slowMA) CurrentDirection = "DOWN";

        if(PreviousDirection=="NONE")
        {
            PreviousDirection = CurrentDirection;
            return("NONE");
        }

        if(PrintControl==true) Print("Prev : ",PreviousDirection," - Curr : ",CurrentDirection);

        if(PreviousDirection!=CurrentDirection)
        {
            PreviousDirection = CurrentDirection;
            return(CurrentDirection);
        }
        else return("NONE");
    }

    //----------------------- OPEN ORDER FUNCTION
    //----------------------- SOURCE   : CODERSGURU
    //----------------------- SOURCE   : PENGIE
    //----------------------- MODIFIED : FIREDAVE
    /**
     * @requires
     *      Global Parameters
     *          NumberOfTries   int
     *      type        int
     *      stoploss    int
     *      takeprofit  int
     * @modifies
     * @effects
     *      return ticket
     */
    int subOpenOrder(int type, int stoploss, int takeprofit)
    {
        int
        ticket      = 0,
        err         = 0,
        c           = 0;

        double         
        aStopLoss   = 0,
        aTakeProfit = 0,
        bStopLoss   = 0,
        bTakeProfit = 0;

        if(stoploss!=0)
        {
            aStopLoss   = NormalizeDouble(Ask-stoploss*Point,4);
            bStopLoss   = NormalizeDouble(Bid+stoploss*Point,4);
        }

        if(takeprofit!=0)
        {
            aTakeProfit = NormalizeDouble(Ask+takeprofit*Point,4);
            bTakeProfit = NormalizeDouble(Bid-takeprofit*Point,4);
        }

        if(type==OP_BUY)
        {
            for(c=0;c<NumberOfTries;c++)
            {
                ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,aStopLoss,aTakeProfit,TicketComment,MagicNumber,0,Green);
                err=GetLastError();
                if(err==0)
                { 
                    if(ticket>0) break;
                }
                else
                {
                    if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                    {
                        Sleep(5000);
                        continue;
                    }
                    else //normal error
                    {
                        if(ticket>0) break;
                    }  
                }
            }   
        }
        if(type==OP_SELL)
        {   
            for(c=0;c<NumberOfTries;c++)
            {
                ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,bStopLoss,bTakeProfit,TicketComment,MagicNumber,0,Red);
                err=GetLastError();
                if(err==0)
                { 
                    if(ticket>0) break;
                }
                else
                {
                    if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                    {
                        Sleep(5000);
                        continue;
                    }
                    else //normal error
                    {
                        if(ticket>0) break;
                    }  
                }
            }   
        }  
        return(ticket);
    }

    //----------------------- CLOSE ORDER FUNCTION
    /**
     * @requires
     *      Global Parameters
     *          NumberOfTries   int
     * @modifies
     * @effects
     */
    void subCloseOrder()
    {
        int
        cnt, 
        total       = 0,
        ticket      = 0,
        err         = 0,
        c           = 0;

        total = OrdersTotal();
        for(cnt=total-1;cnt>=0;cnt--)
        {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

            if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
            {
                switch(OrderType())
                {
                    case OP_BUY      :
                    for(c=0;c<NumberOfTries;c++)
                    {
                        ticket=OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
                        err=GetLastError();
                        if(err==0)
                        { 
                            if(ticket>0) break;
                        }
                        else
                        {
                            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                            {
                                Sleep(5000);
                                continue;
                            }
                            else //normal error
                            {
                                if(ticket>0) break;
                            }  
                        }
                    }   
                    break;

                    case OP_SELL     :
                    for(c=0;c<NumberOfTries;c++)
                    {
                        ticket=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
                        err=GetLastError();
                        if(err==0)
                        { 
                            if(ticket>0) break;
                        }
                        else
                        {
                            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                            {
                                Sleep(5000);
                                continue;
                            }
                            else //normal error
                            {
                                if(ticket>0) break;
                            }  
                        }
                    }   
                    break;

                    case OP_BUYLIMIT :
                    case OP_BUYSTOP  :
                    case OP_SELLLIMIT:
                    case OP_SELLSTOP :
                    OrderDelete(OrderTicket());
                }
            }
        }      
    }

    //----------------------- TRAILING STOP FUNCTION
    //----------------------- SOURCE   : CODERSGURU
    //----------------------- MODIFIED : FIREDAVE
    void subTrailingStop(int Type)
    {
        if(Type==OP_BUY)   // buy position is opened   
        {
            switch(TrailingStopType)
            {
                //----------------------- AFTER PROFIT TRAILING STOP      
                case 1:
                if(Bid-OrderOpenPrice()>Point*TrailingStop &&
                OrderStopLoss()<Bid-Point*TrailingStop)
                {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                    return(0);
                }
                break;

                //----------------------- TRAILING STOP
                case 2:
                if(Bid>OrderOpenPrice() &&
                OrderStopLoss()<Bid-Point*TrailingStop)
                {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                    return(0);
                }
                break;

                //----------------------- DEFAULT : AFTER PROFIT TRAILING STOP      
                default:
                if(Bid-OrderOpenPrice()>Point*TrailingStop &&
                OrderStopLoss()<Bid-Point*TrailingStop)
                {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                    return(0);
                }  
            }
        }

        if(Type==OP_SELL)   // sell position is opened   
        {
            switch(TrailingStopType)
            {
                //----------------------- AFTER PROFIT TRAILING STOP      
                case 1:
                if(OrderOpenPrice()-Ask>Point*TrailingStop)
                {
                    if(OrderStopLoss()>Ask+Point*TrailingStop || OrderStopLoss()==0)
                    {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                        return(0);
                    }
                }
                break;

                //----------------------- TRAILING STOP
                case 2:
                if(OrderOpenPrice()>Ask)
                {
                    if(OrderStopLoss()>Ask+Point*TrailingStop || OrderStopLoss()==0)
                    {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                        return(0);
                    }
                }
                break;

                //----------------------- DEFAULT : AFTER PROFIT TRAILING STOP      
                default:
                if(OrderOpenPrice()-Ask>Point*TrailingStop)
                {
                    if(OrderStopLoss()>Ask+Point*TrailingStop || OrderStopLoss()==0)
                    {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                        return(0);
                    }
                }
            }
        }
    }

    //----------------------- CHECK ERROR CODE FUNCTION
    //----------------------- SOURCE : CODERSGURU
    void subCheckError(int ticket, string Type)
    {
        if(ticket>0) 
        {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
                Print(Type + " order opened : ",OrderOpenPrice());
        }
        else 
            Print("Error opening " + Type + " order : (",GetLastError(),") ", ErrorDescription(GetLastError()));
    }

    //----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
    //----------------------- SOURCE   : PENGIE
    //----------------------- MODIFIED : FIREDAVE
    int subGenerateMagicNumber(int MagicNumber, string symbol, int timeFrame)
    {
        int isymbol = 0;
        if (symbol == "EURUSD")       isymbol = 1;
        else if (symbol == "GBPUSD")  isymbol = 2;
        else if (symbol == "USDJPY")  isymbol = 3;
        else if (symbol == "USDCHF")  isymbol = 4;
        else if (symbol == "AUDUSD")  isymbol = 5;
        else if (symbol == "USDCAD")  isymbol = 6;
        else if (symbol == "EURGBP")  isymbol = 7;
        else if (symbol == "EURJPY")  isymbol = 8;
        else if (symbol == "EURCHF")  isymbol = 9;
        else if (symbol == "EURAUD")  isymbol = 10;
        else if (symbol == "EURCAD")  isymbol = 11;
        else if (symbol == "GBPUSD")  isymbol = 12;
        else if (symbol == "GBPJPY")  isymbol = 13;
        else if (symbol == "GBPCHF")  isymbol = 14;
        else if (symbol == "GBPAUD")  isymbol = 15;
        else if (symbol == "GBPCAD")  isymbol = 16;
        else                          isymbol = 17;
        if(isymbol<10) MagicNumber = MagicNumber * 10;
        return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
    }

    //----------------------- PRINT COMMENT FUNCTION
    //----------------------- SOURCE : CODERSGURU
    void subPrintDetails()
    {
        string sComment   = "";
        string sp         = "----------------------------------------\n";
        string NL         = "\n";

        sComment = sp;
        sComment = sComment + "TakeProfit=" + DoubleToStr(TakeProfit,0) + " | ";
        sComment = sComment + "TrailingStop=" + DoubleToStr(TrailingStop,0) + " | ";
        sComment = sComment + "StopLoss=" + DoubleToStr(StopLoss,0) + NL; 
        sComment = sComment + sp;
        sComment = sComment + "Reverse Entry Condition=" + subBoolToStr(ReverseCondition) + NL;
        sComment = sComment + "Confirmed On Entry=" + subBoolToStr(ConfirmedOnEntry) + NL;
        sComment = sComment + "Stop And Reverse=" + subBoolToStr(StopAndReverse) + NL;
        sComment = sComment + "Pure SAR=" + subBoolToStr(PureSAR) + NL;
        sComment = sComment + sp;
        sComment = sComment + "Lots=" + DoubleToStr(Lots,2) + " | ";
        sComment = sComment + "MM=" + subBoolToStr(MM) + " | ";
        sComment = sComment + "Risk=" + DoubleToStr(Risk,0) + "%" + NL;
        sComment = sComment + sp;

        Comment(sComment);
    }

    //----------------------- BOOLEN VARIABLE TO STRING FUNCTION
    //----------------------- SOURCE : CODERSGURU
    string subBoolToStr ( bool value)
    {
        if(value==true) return ("True");
        else return ("False");
    }

    //----------------------- ALERT ON MA CROSS
    //----------------------- SOURCE : FIREDAVE
    void subCrossAlert(string type)
    {
        string AlertComment;

        if(type=="UP")   AlertComment = "Moving Average Cross UP !";
        if(type=="DOWN") AlertComment = "Moving Average Cross DOWN !";

        Alert(AlertComment);
        PlaySound(SoundFilename);
    }

//----------------------- END FUNCTION